#ifndef G_MAIN_H
#define G_MAIN_H

#include "gens.h"

#ifdef __cplusplus
extern "C" {
#endif


#define X_RES 320
#define Y_RES 240

#define TIMER_ID    1
#define TIMER_RATE  30

extern HINSTANCE ghInstance;
extern WNDCLASS WndClass;
extern int HWnd;
extern HMENU Gens_Menu;

extern int Paused;
extern int Net_Play;
extern int Current_State;
extern int Full_Screen;
extern int Fast_Blur;
extern int Render_W;
extern int Render_FS;
extern int Show_FPS;
extern int Show_Message;
extern int Show_LED;
extern int Auto_Pause;
extern int Auto_Fix_CS;
extern int Language;
extern int Country;
extern int Country_Order[3];
extern int WinNT_Flag;
extern int Gens_Priority;
extern int Kaillera_Client_Running;
extern int Intro_Style;
extern int SegaCD_Accurate;
extern int MoviePlaying;
extern int FrameCounterEnabled; //Modif IM/N
extern int FrameCounterPosition; //Modif IM/N
extern int ShowInputEnabled; //Modif IM/N
extern int MovieRecording; //Modif IM/N
extern int AutoBackupEnabled; //Modif IM/N
extern int WindowX; //Modif IM
extern int WindowY; //Modif IM
extern int SpeedChangeFactor; //Modif N
extern int SpeedChangeEnabled; //Modif N
extern int DisableBlueScreen; //Modif N/IM

//Modif IM - make all input configurable
extern SDL_keysym Pause_Emulator_key;
extern SDL_keysym Quit_key;
extern SDL_keysym Take_Screenshot_key;
extern SDL_keysym Fast_Forward_key;
extern SDL_keysym Reset_key;
extern SDL_keysym Lower_Speed_key;
extern SDL_keysym Raise_Speed_key;
extern SDL_keysym Toggle_Fullscreen_key;
extern SDL_keysym Change_Stretch_key;
extern SDL_keysym Auto_Frameskip_key;
extern SDL_keysym Change_Vsync_key;
extern SDL_keysym Lower_Frameskip_key;
extern SDL_keysym Raise_Frameskip_key;
extern SDL_keysym Save_Current_State_key;
extern SDL_keysym Alt_Save_Current_State_key;
extern SDL_keysym Select_Previous_State_key;
extern SDL_keysym Select_Next_State_key;
extern SDL_keysym Load_Current_State_key;
extern SDL_keysym Alt_Load_Current_State_key;
extern SDL_keysym Change_Blit_Style_key;
extern SDL_keysym Toggle_Fast_Blur_key;
extern SDL_keysym Toggle_Improved_DAC_key;
extern SDL_keysym Toggle_FPS_Display_key;
extern SDL_keysym Toggle_Improved_PSG_key;
extern SDL_keysym Previous_Rendering_Mode_key;
extern SDL_keysym Toggle_Improved_YM2612_key;
extern SDL_keysym Next_Rendering_Mode_key;
extern SDL_keysym Select_State_0_key;
extern SDL_keysym Select_State_1_key;
extern SDL_keysym Select_State_2_key;
extern SDL_keysym Select_State_3_key;
extern SDL_keysym Select_State_4_key;
extern SDL_keysym Select_State_5_key;
extern SDL_keysym Select_State_6_key;
extern SDL_keysym Select_State_7_key;
extern SDL_keysym Select_State_8_key;
extern SDL_keysym Select_State_9_key;
extern SDL_keysym Load_State_0_key;
extern SDL_keysym Load_State_1_key;
extern SDL_keysym Load_State_2_key;
extern SDL_keysym Load_State_3_key;
extern SDL_keysym Load_State_4_key;
extern SDL_keysym Load_State_5_key;
extern SDL_keysym Load_State_6_key;
extern SDL_keysym Load_State_7_key;
extern SDL_keysym Load_State_8_key;
extern SDL_keysym Load_State_9_key;
extern SDL_keysym Save_State_0_key;
extern SDL_keysym Save_State_1_key;
extern SDL_keysym Save_State_2_key;
extern SDL_keysym Save_State_3_key;
extern SDL_keysym Save_State_4_key;
extern SDL_keysym Save_State_5_key;
extern SDL_keysym Save_State_6_key;
extern SDL_keysym Save_State_7_key;
extern SDL_keysym Save_State_8_key;
extern SDL_keysym Save_State_9_key;
extern SDL_keysym Close_ROM_key;
extern SDL_keysym Open_Game_Genie_key;
extern SDL_keysym Change_SegaCD_Syncro_key;
extern SDL_keysym Start_Playing_GYM_key;
extern SDL_keysym Change_CD_key;
extern SDL_keysym Toggle_WAV_Dumping_key;
extern SDL_keysym RAM_Search_Menu_key;
extern SDL_keysym Start_Recording_key;
extern SDL_keysym Toggle_Readonly_key;
extern SDL_keysym Play_Movie_key;
extern SDL_keysym Toggle_Frame_Counter_key;
extern SDL_keysym Advance_Frame_key;
extern SDL_keysym Toggle_Input_Display_key;
extern SDL_keysym Toggle_Sound_key;
extern SDL_keysym Stop_Movie_key;
extern SDL_keysym Record_New_Movie_key;
extern SDL_keysym Load_State_File_key;
extern SDL_keysym Save_State_File_key;
extern SDL_keysym Save_Config_File_key;

extern unsigned MovieLastFrame;

extern POINT Window_Pos;

extern char Str_Tmp[1024];
extern char Gens_Path[1024];
extern char Language_Path[1024];
extern char CGOffline_Path[1024];
extern char Manual_Path[1024];

extern char **language_name;

int Set_Render(HWND hWnd, int Full, int Num, int Force);
int Change_68K_Type(int hWnd, int Num, int Reset_SND);
int Change_Sound(int hWnd);
HMENU Build_Main_Menu(void);


int Check_Key_Pressed(SDL_keysym* ks);
void End_All(void);
void Sleep(int i);
void Update_Input();
void update_events();
int Set_Sprite_Over(HWND hWnd, int Num);
int Set_Current_State(int hWnd, int Num);
int Set_Frame_Skip(HWND hWnd, int Num);
int Change_Debug(HWND hWnd, int Debug_Mode);
int Change_Country_Order(int Num);
int Change_Country(HWND hWnd, int Num);
int Change_SegaCD_Synchro(void);
int	Change_Sound(HWND hWnd);
int Change_Sample_Rate(HWND hWnd, int Rate);
int Change_Sound_Stereo(HWND hWnd);
int Change_Z80(HWND hWnd);
int Change_PSG(HWND hWnd);
int Change_PCM(HWND hWnd);
int Change_PWM(HWND hWnd);
int Change_DAC(HWND hWnd);
int Change_CDDA(HWND hWnd);
int Change_Fast_Blur(HWND hWnd);
int Change_Stretch(void);
int Change_VSync(HWND hWnd);
int Change_Blit_Style(void);
int Change_DAC_Improv(HWND hWnd);
int Change_SegaCD_SRAM_Size(int num);
int Change_YM2612(HWND hWnd);
int Change_PSG_Improv(HWND hWnd);
int Change_YM2612_Improv(HWND hWnd);
int Build_Language_String(void);

void PlayMovie(char*, char*);
void NewMovieMenu(void);

#ifdef WITH_GTK

#include <gtk/gtk.h>
extern GtkWidget* gens_window;

#endif


#ifdef __PORT__
void win2linux(char* str);
#endif


#define MESSAGE_L(str, def, time)																	\
{																									\
	GetPrivateProfileString(language_name[Language], (str), (def), Str_Tmp, 1024, Language_Path);	\
	Put_Info(Str_Tmp, (time));																		\
}



#define MESSAGE_NUM_L(str, def, num, time)															\
{																									\
	char mes_tmp[1024];																				\
	GetPrivateProfileString(language_name[Language], (str), (def), Str_Tmp, 1024, Language_Path);	\
	sprintf(mes_tmp, Str_Tmp, (num));																\
	Put_Info(mes_tmp, (time));																		\
}

//Modif IM - change focus to cli or window
#define CLI_FOCUS \
    swi.info.x11.lock_func(); \
    XLowerWindow(swi.info.x11.display,swi.info.x11.wmwindow); \
    XSetInputFocus(swi.info.x11.display,PointerRoot,RevertToNone,CurrentTime); \
    swi.info.x11.unlock_func();

#define WINDOW_FOCUS \
    swi.info.x11.lock_func(); \
    XRaiseWindow(swi.info.x11.display,swi.info.x11.wmwindow); \
    XSetInputFocus(swi.info.x11.display,swi.info.x11.wmwindow,RevertToPointerRoot,CurrentTime); \
    swi.info.x11.unlock_func();

//Modif IM - less typing
#define IsPressed(button) keysyms_match((button),&event.key.keysym)

#ifdef __cplusplus
}
#endif

#endif

