#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <X11/Xlib.h>
#include <readline/readline.h>
#include <SDL/SDL.h>
#include "gens.h"
#include "g_main.h"
#include "io.h"
#include "g_ddraw.h"
#include "g_input.h"
#include "movie.h"
#include "mem_m68k.h"
long unsigned int FrameCount;
char Movie_Dir[1024]="";
typeMovie MainMovie;

//Modif
void MoviePlayingStuff()
{
	char PadData[3]; //Modif

    //Modif IM - because I'm not very smart
    if (MainMovie.File == NULL)
        fprintf(stderr,"attempt to read from unopened movie file\n");

	//Check_Misc_Key(); //Modif IM - not sure why this is needed
	fseek(MainMovie.File,64+FrameCount*3,SEEK_SET);
	fread(PadData,3,1,MainMovie.File);
	Controller_1_Up=(PadData[0]&1);
	Controller_1_Down=(PadData[0]&2)>>1;
	Controller_1_Left=(PadData[0]&4)>>2;
	Controller_1_Right=(PadData[0]&8)>>3;
	Controller_1_A=(PadData[0]&16)>>4;
	Controller_1_B=(PadData[0]&32)>>5;
	Controller_1_C=(PadData[0]&64)>>6;
	Controller_1_Start=(PadData[0]&128)>>7;
	if(MainMovie.TriplePlayerHack)
	{
		Controller_1B_Up=(PadData[1]&1);
		Controller_1B_Down=(PadData[1]&2)>>1;
		Controller_1B_Left=(PadData[1]&4)>>2;
		Controller_1B_Right=(PadData[1]&8)>>3;
		Controller_1B_A=(PadData[1]&16)>>4;
		Controller_1B_B=(PadData[1]&32)>>5;
		Controller_1B_C=(PadData[1]&64)>>6;
		Controller_1B_Start=(PadData[1]&128)>>7;
		Controller_1C_Up=(PadData[2]&1);
		Controller_1C_Down=(PadData[2]&2)>>1;
		Controller_1C_Left=(PadData[2]&4)>>2;
		Controller_1C_Right=(PadData[2]&8)>>3;
		Controller_1C_A=(PadData[2]&16)>>4;
		Controller_1C_B=(PadData[2]&32)>>5;
		Controller_1C_C=(PadData[2]&64)>>6;
		Controller_1C_Start=(PadData[2]&128)>>7;
	}
	else
	{
		Controller_2_Up=(PadData[1]&1);
		Controller_2_Down=(PadData[1]&2)>>1;
		Controller_2_Left=(PadData[1]&4)>>2;
		Controller_2_Right=(PadData[1]&8)>>3;
		Controller_2_A=(PadData[1]&16)>>4;
		Controller_2_B=(PadData[1]&32)>>5;
		Controller_2_C=(PadData[1]&64)>>6;
		Controller_2_Start=(PadData[1]&128)>>7;
		Controller_1_X=(PadData[2]&1);
		Controller_1_Y=(PadData[2]&2)>>1;
		Controller_1_Z=(PadData[2]&4)>>2;
		Controller_1_Mode=(PadData[2]&8)>>3;
		Controller_2_X=(PadData[2]&16)>>4;
		Controller_2_Y=(PadData[2]&32)>>5;
		Controller_2_Z=(PadData[2]&64)>>6;
		Controller_2_Mode=(PadData[2]&128)>>7;
	}
	
	if(FrameCount>=MainMovie.LastFrame-1)
	{
		MainMovie.MovieStatus=MOVIE_FINISHED;
		sprintf(Str_Tmp, "Movie finished");
		Put_Info(Str_Tmp, 2000);
	}
}

//Modif
void MovieRecordingStuff()
{
	char PadData[3]; //Modif
	PadData[0] = Controller_1_Up+
                (Controller_1_Down<<1)+
                (Controller_1_Left<<2)+
                (Controller_1_Right<<3)+
                (Controller_1_A<<4)+
                (Controller_1_B<<5)+
                (Controller_1_C<<6)+
                (Controller_1_Start<<7);
	if(MainMovie.TriplePlayerHack)
	{
	PadData[1] = Controller_1B_Up+
                (Controller_1B_Down<<1)+
                (Controller_1B_Left<<2)+
                (Controller_1B_Right<<3)+
                (Controller_1B_A<<4)+
                (Controller_1B_B<<5)+
                (Controller_1B_C<<6)+
                (Controller_1B_Start<<7);
	PadData[2]=Controller_1C_Up+
              (Controller_1C_Down<<1)+
              (Controller_1C_Left<<2)+
              (Controller_1C_Right<<3)+
              (Controller_1C_A<<4)+
              (Controller_1C_B<<5)+
              (Controller_1C_C<<6)+
              (Controller_1C_Start<<7);
	
	}
	else
	{
	PadData[1] = Controller_2_Up+
                (Controller_2_Down<<1)+
                (Controller_2_Left<<2)+
                (Controller_2_Right<<3)+
                (Controller_2_A<<4)+
                (Controller_2_B<<5)+
                (Controller_2_C<<6)+
                (Controller_2_Start<<7);
	PadData[2]= Controller_1_X+
                (Controller_1_Y<<1)+
                (Controller_1_Z<<2)+
                (Controller_1_Mode<<3)+
                (Controller_2_X<<4)+
                (Controller_2_Y<<5)+
                (Controller_2_Z<<6)+
                (Controller_2_Mode<<7);
	}
	fseek(MainMovie.File,64+FrameCount*3,SEEK_SET);
	fwrite(PadData,3,1,MainMovie.File);
	MainMovie.LastFrame=FrameCount;
}

void InitMovie(typeMovie * aMovie)
{
	aMovie->File=NULL;
	strcpy(aMovie->FileName,"");
	aMovie->LastFrame=0;
	aMovie->NbRerecords=0;
	strcpy(aMovie->Note,"");
	aMovie->Player1Config=6;
	aMovie->Player2Config=3;
	aMovie->ReadOnly=1; //Modif IM - annoying for movie makers, but better for watchers
	strcpy(aMovie->StateName,"");
	aMovie->MovieStatus=0;
	aMovie->UseState=0;
	aMovie->Version='A'-'0';
	aMovie->Ok=0;
	aMovie->StateFrame=0;
	aMovie->StateOk=0;
	aMovie->Vfreq=(CPU_Mode)?1:0;
	aMovie->StateRequired=0;
	aMovie->TriplePlayerHack=0;
}

//Modif IM - debugging
void PrintMovie(typeMovie * aMovie)
{
    fprintf(stderr,"printing movie info\n");
    
    if (aMovie->File == NULL)
        fprintf(stderr,"file is null\n");
    else
        fprintf(stderr,"file is set\n");

    fprintf(stderr,"filename is \"%s\"\n",aMovie->FileName);
    fprintf(stderr,"last frame is %d\n",aMovie->LastFrame);
    fprintf(stderr,"rerecord count is %d\n",aMovie->NbRerecords);
    fprintf(stderr,"player config is %d/%d\n",aMovie->Player1Config,aMovie->Player2Config);
    fprintf(stderr,"read-only: %d\n",aMovie->ReadOnly);
    fprintf(stderr,"state name is \"%s\"\n",aMovie->StateName);
    fprintf(stderr,"status is %d\n",aMovie->MovieStatus);
    fprintf(stderr,"uses state: %d\n",aMovie->UseState);
    fprintf(stderr,"version is %d\n",aMovie->Version);
    fprintf(stderr,"movie Ok: %d\n",aMovie->Ok);
    fprintf(stderr,"state frame is %d\n",aMovie->StateFrame);
    fprintf(stderr,"state ok: %d\n",aMovie->StateOk);
    fprintf(stderr,"vfreq is %d\n",aMovie->Vfreq);
    fprintf(stderr,"requires state: %d\n",aMovie->StateRequired);
    fprintf(stderr,"triple-player: %d\n",aMovie->TriplePlayerHack);
}
           

void CopyMovie(typeMovie * MovieSrc, typeMovie * MovieDest)
{
	MovieDest->File=MovieSrc->File;
	strncpy(MovieDest->FileName,MovieSrc->FileName,1024);
	MovieDest->LastFrame=MovieSrc->LastFrame;
	MovieDest->NbRerecords=MovieSrc->NbRerecords;
	strncpy(MovieDest->Note,MovieSrc->Note,41);
	MovieDest->Player1Config=MovieSrc->Player1Config;
	MovieDest->Player2Config=MovieSrc->Player2Config;
	MovieDest->ReadOnly=MovieSrc->ReadOnly;
	strncpy(MovieDest->StateName,MovieSrc->StateName,1024);
	MovieDest->MovieStatus=MovieSrc->MovieStatus;
	MovieDest->UseState=MovieSrc->UseState;
	MovieDest->Version=MovieSrc->Version;
	MovieDest->Ok=MovieSrc->Ok;
	MovieDest->StateOk=MovieSrc->StateOk;
	strncpy(MovieDest->Header,MovieSrc->Header,17);
	MovieDest->StateFrame=MovieSrc->StateFrame;
	MovieDest->Vfreq=MovieSrc->Vfreq;
	MovieDest->TriplePlayerHack=MovieSrc->TriplePlayerHack;
	MovieDest->StateRequired=MovieSrc->StateRequired;
}

void GetMovieInfo(char *FileName,typeMovie *aMovie)
{
	FILE *test;
	char Header[11];
	unsigned char t;

	test=fopen(FileName,"rb");
	if(test==NULL)
	{
		aMovie->Ok=0;
		return;
	}

	fseek(test,0,SEEK_END);
	if(ftell(test)<64)
	{
		aMovie->Ok=0;
		fclose(test);
		return;
	}

	aMovie->LastFrame=(ftell(test)-64)/3;

	fseek(test,0,SEEK_SET);
	fread(Header,1,10,test);
	Header[10]=0;
	if(strcmp(Header,"Gens Movie"))
	{
		aMovie->Ok=0;
		fclose(test);
		return;
	}

	fseek(test,0,SEEK_SET);
	fread(aMovie->Header,1,16,test);
	aMovie->Header[17]=0;

	fseek(test,15,SEEK_SET);
	aMovie->Version=fgetc(test)-'0';

	fseek(test,0,SEEK_END);
	aMovie->LastFrame=(ftell(test)-64)/3;

	fseek(test,16,SEEK_SET);
	fread((char*)&aMovie->NbRerecords,sizeof(aMovie->NbRerecords),1,test);

	aMovie->Ok=1;

	strncpy(aMovie->FileName,FileName,1024);

	if(aMovie->Version>=9)
	{
		fseek(test,24,SEEK_SET);
		fread(aMovie->Note,40,1,test);
		aMovie->Note[40]=0;
		fseek(test,20,SEEK_SET);
		aMovie->Player1Config=fgetc(test)-'0';
		aMovie->Player2Config=fgetc(test)-'0';
		if(aMovie->Version>=('A'-'0'))
		{
			fseek(test,22,SEEK_SET);
			t=fgetc(test);
			aMovie->Vfreq=((t&128)>>7);
			aMovie->StateRequired=((t&64)>>6);
			aMovie->TriplePlayerHack=((t&32)>>5);
		}
		else
		{
			aMovie->Vfreq=CPU_Mode?1:0;
			aMovie->StateRequired=0;
			aMovie->TriplePlayerHack=0;
		}
	}
	else
	{
		strncpy(aMovie->Note,"None.  Movie version earlier than TEST9.",40);
		aMovie->Player1Config=0;
		aMovie->Player2Config=0;
		aMovie->Vfreq=(CPU_Mode)?1:0;
	}
	fclose(test);
}

void GetStateInfo(char * FileName,typeMovie *aMovie)
{
	FILE *test;

	test=fopen(FileName,"rb");

	if(test==NULL)
	{
		aMovie->StateOk=0;
		return;
	}

	fseek(test,0,SEEK_END);

	if(ftell(test)<0x2247C)
	{
		aMovie->StateOk=0;
		fclose(test);
		return;
	}

	strncpy(aMovie->StateName,FileName,1024);

	fseek(test,0x22478,SEEK_SET);

	aMovie->StateFrame=fgetc(test);
	aMovie->StateFrame+=fgetc(test)<<8;
	aMovie->StateFrame+=fgetc(test)<<16;
	aMovie->StateFrame+=fgetc(test)<<24;

	aMovie->StateOk=1;
	fclose(test);
}

int OpenMovieFile(typeMovie *aMovie)
{
	if(aMovie->Ok==0)
		return 0;
	if(aMovie->ReadOnly)
	{
		aMovie->File=fopen(aMovie->FileName,"r+b"); //Modif N - so we can toggle readonly without re-opening file
		if(!aMovie->File)
			aMovie->File=fopen(aMovie->FileName,"rb");
	}
	else	
		aMovie->File=fopen(aMovie->FileName,"r+b");

	if(aMovie->File==NULL)
		return 0;

	return 1;
}

int CloseMovieFile(typeMovie *aMovie)
{
	unsigned int MovieFileLastFrame=0;
	char * movieData;
	unsigned char t;

	if(aMovie->File==NULL)
		return 0;
	if(aMovie->ReadOnly==0)
	{
		fseek(aMovie->File,16,SEEK_SET);
		fwrite((char*)&aMovie->NbRerecords,sizeof(aMovie->NbRerecords),1,aMovie->File);
		if(aMovie->Version>=9)
		{
			fseek(aMovie->File,20,SEEK_SET);
			if((Controller_1_Type & 1)==1)
				fputc('6',aMovie->File);
			else
				fputc('3',aMovie->File);
			if((Controller_2_Type & 1)==1)
				fputc('6',aMovie->File);
			else
				fputc('3',aMovie->File);
			if(aMovie->Version>='A'-'0')
			{
				fseek(aMovie->File,22,SEEK_SET);
				t=fgetc(aMovie->File);
				t= (t&127) + ((CPU_Mode)?128:0);
				t= (t&191) + ((aMovie->StateRequired)?64:0);
				t= (t&223) + ((aMovie->TriplePlayerHack)?32:0);
				fseek(aMovie->File,22,SEEK_SET);
				fputc(t,aMovie->File);
			}
			fseek(aMovie->File,24,SEEK_SET);
			fwrite(aMovie->Note,40,1,aMovie->File);
		}
		fseek(aMovie->File,0,SEEK_END);
		MovieFileLastFrame=(ftell(aMovie->File)-64)/3;
		if(MovieFileLastFrame>aMovie->LastFrame)
		{
			fseek(aMovie->File,0,SEEK_SET);
			movieData=new char[aMovie->LastFrame*3+64];
			fread(movieData,aMovie->LastFrame*3+64,1,aMovie->File);
		}
	}

	fclose(aMovie->File);
	aMovie->File=NULL;
	
	if(MovieFileLastFrame>aMovie->LastFrame)
	{
		aMovie->File=fopen(aMovie->FileName,"wb");
		fseek(aMovie->File,0,SEEK_SET);
		fwrite(movieData,aMovie->LastFrame*3+64,1,aMovie->File);
		fclose(aMovie->File);
		delete[] movieData;
	}

	InitMovie(aMovie);
	return 1;
}

int BackupMovieFile(typeMovie *aMovie)
{
	char * movieData;
	FILE* Backup;

	if(aMovie->File==NULL)
		return 0;

    Put_Info(aMovie->FileName, 2000);

	Backup=fopen(aMovie->FileName,"wb");

	if(Backup==NULL)
		return 0;

	fseek(aMovie->File,0,SEEK_SET);
	movieData=new char[aMovie->LastFrame*3+64];
	fread(movieData,aMovie->LastFrame*3+64,1,aMovie->File);
	fseek(Backup,0,SEEK_SET);
	fwrite(movieData,aMovie->LastFrame*3+64,1,Backup);
	fclose(Backup);
	Backup=NULL;

	delete[] movieData;

	return 1;
}


