#ifndef RAM_SEARCH_H
#define RAM_SEARCH_H

#ifdef __cplusplus
extern "C" {
#endif

#define RAM_SIZE 64*1024 + 8*1024
#define RAM_VAL(x) ((x)<(1024*64)?Ram_68k[(x)]:Ram_Z80[(x)- 1024*64])
#define RAM_VALS_SHOW 10

void RAM_Search_Menu(void);
void clear_results(void);
void get_curr(void);
void update_results(void);
void prompt_prune(const char*);
void display_results(void);
int read_ramview_file(char*);
void free_ramview_comments(void);
int find_decreasing();
int find_less_than(int);
int find_increasing();
int find_greater_than(int);
int find_increased_by(int);
int find_decreased_by(int);
int find_unchanged();
int find_equal_to(int);
int find_changed();
int find_not_equal_to(int);
int find_value_at(int);

extern int good[RAM_SIZE];
extern int prev[RAM_SIZE];
extern int curr[RAM_SIZE];
extern int show_ram[]; 


#ifdef __cplusplus
}
#endif

#endif

