#ifndef SAVE_H_
#define SAVE_H_

#include <stdio.h>

#ifdef __cplusplus
extern "C" {
#endif

#define GENESIS_STATE_FILE_LENGHT    0x2247C //Modif N/IM
#define GENESIS_STATE_FILE_LENGHT_EX 0x25554 //Modif N/IM
#define SEGACD_STATE_FILE_LENGHT     (0x22500 + 0xE0000)
#define G32X_STATE_FILE_LENGHT       (0x22500 + 0x82A00)
#define SCD32X_STATE_FILE_LENGHT     (0x22500 + 0xE0000 + 0x82A00)
#define MAX_STATE_FILE_LENGHT        SCD32X_STATE_FILE_LENGHT
//Modif IM - undefined value for SDLKey
#define SDLK_NONE 1

extern char State_Dir[1024];
extern char SRAM_Dir[1024];
extern char BRAM_Dir[1024];

int Change_File_S(char *Dest, char *Dir, char *Titre, char *Filter, char *Ext);
int Change_File_L(char *Dest, char *Dir, char *Titre, char *Filter, char *Ext);
int Change_Dir(char *Dest, char *Dir, char *Titre, char *Filter, char *Ext);
FILE *Get_State_File();
void Get_State_File_Name(char *name);
int Load_State(char *Name);
int Save_State(char *Name);
void Import_Genesis(unsigned char *Data);
void Export_Genesis(unsigned char *Data);
void Import_SegaCD(unsigned char *Data);
void Export_SegaCD(unsigned char *Data);
void Import_32X(unsigned char *Data);
void Export_32X(unsigned char *Data);
int Save_Config(char *File_Name);
int Save_As_Config(HWND hWnd);
int Load_Config(char *File_Name, void *Game_Active);
void ascii2SDLK(char* str, SDL_keysym* ks);
void SDLK2ascii(char* str, SDL_keysym* ks);
int keysyms_match(SDL_keysym* k1, SDL_keysym* k2);
void print_SDLK(SDL_keysym* ks);
int Load_As_Config(HWND hWnd, void *Game_Active);
int Load_SRAM(void);
int Save_SRAM(void);
int Load_BRAM(void);
int Save_BRAM(void);
void Format_Backup_Ram(void);

//Modif IM - less typing
#define SetInterfaceKey(name,def,var) \
    GetPrivateProfileString("Interface",(name),(def),&Str_Tmp[0], 1024, Conf_File); \
    ascii2SDLK(Str_Tmp,&(var));

//Modif IM - a lot less typing
#define SetInputKey(name,def,var) \
{ \
    GetPrivateProfileString("Input",(name),(def),&Str_Tmp[0], 1024, Conf_File); \
    SDL_keysym tmp_keysym; \
    ascii2SDLK(Str_Tmp,&tmp_keysym); \
    (var) = tmp_keysym.sym; \
}

#define WriteInterfaceKey(name,val) \
    SDLK2ascii(Str_Tmp,&(val)); \
    WritePrivateProfileString("Interface",(name),&Str_Tmp[0], Conf_File);

#define WriteSDLKey(fh,name,val) \
{ \
    SDL_keysym ks; \
    ks.mod = (SDLMod)0; \
    ks.sym = (SDLKey)val; \
    SDLK2ascii(Str_Tmp,&(ks)); \
    fprintf((fh),"%s=%s\n",name,&Str_Tmp[0]); \
}

#define WriteSDLkeysym(fh,name,ks) \
{ \
    SDLK2ascii(Str_Tmp,&(ks)); \
    fprintf((fh),"%s=%s\n",name,&Str_Tmp[0]); \
}

#define WritePrivateProfileInt(section,var,var_name,file_name) \
    sprintf(Str_Tmp,"%d",(var_name)); \
    WritePrivateProfileString((section),(var),&Str_Tmp[0],(file_name));

#ifdef __cplusplus
};
#endif

#endif

